function [dP,OutVar,R] = MfxLogit(beta,x,discrete,delta,VarMat)
%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here
N=max(size(beta));
R=zeros(N,N);
dP=zeros(1,N);
for i=1:N
    II=1:N;
    II(i)=[];
    if discrete(i)==1
        x2=x;
        x2(i)=x(i)+delta(i);
        bx=beta*x;
        bx2=beta*x2;
        denom=((1+exp(bx) )*(1+exp(bx2) ))^2;
        dP(i)=(exp(bx2)/(exp(bx2)+1))-(exp(bx)/(exp(bx)+1));
        %Diagonal Terms
        R(i,i)=2*exp(bx+bx2)*(delta(i)+x2(i)*cosh(bx)-x(i)*cosh(bx2) )/denom;
        %Off diagnoal terms
        for j=1:N-1
            R(i,II(j))=-( exp(bx)*( exp(beta(i)*delta(i))-1 )*( exp(bx+bx2)-1 )*x(II(j))   )/denom;
        end
    else
        bx=beta*x;
        denom=2*(1+cosh(bx) )^2;
        R(i,i)=(1+cosh(bx)-beta(i)*x(i)*sinh(bx))/denom;
        dP(i)=beta(i)*(exp(bx)/(exp(bx2)+1)^2);
        for j=1:N-1
            R(i,II(j))=-( beta(i)*x(II(j))*sinh(bx) )/denom;
        end
    end
    OutVar=R*VarMat*R';
end

