function [OutMat dOutVec]=CharacteristicCount(CharMat,ProximityMat,Involved,Assignment)
%The characteristic matrix is an array detailing the relationships between
%people
%The proximity Matrix is a matrix detailing relationships between offices

dimCharM=max(size(CharMat));
dimInvolved=max(size(Involved));
Characteristics=CharMat(Involved,Involved);
OutMat=zeros(dimCharM,dimCharM);

%For each characteristic in the final allocation Matrix
for i=1:dimInvolved
    OutMat( Involved(i) , Involved(i) )= Characteristics(i,:)*ProximityMat( Assignment, Assignment(i) )  ;
    for j=i+1:dimInvolved
        AssignmentI=Assignment;
        AssignmentI(i)=Assignment(j);
        AssignmentI(j)=Assignment(i);
        OutMat( Involved(i) , Involved(j) )= Characteristics(i,:)*ProximityMat( AssignmentI, AssignmentI(i) )  ;
        OutMat( Involved(j) , Involved(i) )= Characteristics(j,:)*ProximityMat( AssignmentI, AssignmentI(j) )  ;
    end
end
zz=1;
for i=1:dimCharM
    for j=i+1:dimCharM
        dOutVec(zz,1)=OutMat(i,i)+OutMat(j,j)-OutMat(j,i)-OutMat(i,j);
        zz=zz+1;
    end
end